COMMENT !
This is a demonstration of how to restrict
characters entered in an edit control
We will use subclassing to achieve this 
www.gunnerinc.com !

.586
.model flat, stdcall

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

SetControlFonts			PROTO	:DWORD,:DWORD
SubClassNumbers			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
SubClassUpper			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
SubClassLower			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
SubClassHex				PROTO	:HWND,:UINT,:WPARAM,:LPARAM

.data
szWndClsMain            BYTE    "ES_MAIN", 0
szWndClsEdit            BYTE    "EDIT", 0
szWndClsStatic          BYTE    "STATIC", 0

szAppName               BYTE    "Restrict Edit Control Characters", 0
szFontName              BYTE    "Verdana", 0
szNumbers               BYTE    "Numbers Only", 0
szUppercase             BYTE    "Uppercase Only", 0
szLowercase             BYTE    "Lowercase Only", 0
szHex                   BYTE    "Hex", 0

.data?
hInst                   DWORD   ?
hMain                   DWORD   ?
hFont                   DWORD   ?
lpNumberProc            DWORD   ?
lpUpperProc             DWORD   ?
lpLowerProc             DWORD   ?
lpHexProc               DWORD   ?
            
.code
start:
    call    Startup
    invoke  ExitProcess, eax

Startup proc
LOCAL   lfnt:LOGFONT
LOCAL   wc:WNDCLASSEX
LOCAL   msg:MSG

    invoke  GetModuleHandle, NULL
    mov     hInst, eax
  
    ;#####  Create 1 fonts
    invoke  RtlZeroMemory, addr lfnt, sizeof LOGFONT

    ;#####  Reg font
    mov     lfnt.lfHeight, -11
    mov     lfnt.lfWeight, FW_NORMAL
    invoke  szCatStr, addr lfnt.lfFaceName, offset szFontName
    invoke  CreateFontIndirect, addr lfnt
    mov     hFont, eax

    ;#####  Register main window class
    invoke  RtlZeroMemory, addr wc, sizeof WNDCLASSEX

    mov     wc.cbSize, sizeof WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, offset WndProcMain
    push    hInst
    pop     wc.hInstance
    mov     wc.hbrBackground, COLOR_3DFACE + 1
    mov     wc.lpszClassName, offset szWndClsMain
    invoke  LoadIcon, NULL, IDI_HAND
    mov     wc.hIcon, eax
    mov     wc.hIconSm, eax
    invoke  LoadCursor, NULL, IDC_ARROW
    mov     wc.hCursor, eax
    invoke  RegisterClassEx, addr wc
    
    ;#####  Coords to center window
    invoke  GetSystemMetrics, SM_CXSCREEN
    sub     eax, 300
    shr     eax, 1
    xchg    eax, ebx
    
    invoke  GetSystemMetrics, SM_CYSCREEN
    sub     eax, 265
    shr     eax, 1

    ;#####  Create main window
    invoke  CreateWindowEx,
                WS_EX_APPWINDOW or WS_EX_CONTROLPARENT,
                offset szWndClsMain,
                offset szAppName,
                WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX or WS_VISIBLE, 
                ebx, eax,
                300, 265,
                HWND_DESKTOP, NULL,
                hInst, NULL
    mov     hMain, eax
        
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke IsDialogMessage, hMain, ADDR msg
		.IF eax ==FALSE
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage, ADDR msg
		.ENDIF
	.ENDW
	mov		eax, msg.message
	ret
	
Startup endp

WndProcMain proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov     eax, uMsg
    .if eax == WM_CREATE
        ;#####  Numbers static
        invoke  CreateWindowEx, 
                    NULL, 
                    offset szWndClsStatic, 
                    offset szNumbers, 
                    WS_CHILD or WS_VISIBLE or SS_LEFT, 
                    5, 5, 
                    117, 17, 
                    hWin, 0, 
                    hInst, 0

        ;#####  Numbers Edit
        invoke  CreateWindowEx, 
                    WS_EX_CLIENTEDGE, 
                    offset szWndClsEdit, 
                    NULL, 
                    WS_CHILD or WS_VISIBLE or WS_TABSTOP, 
                    5, 20, 
                    285, 20, 
                    hWin, 0, 
                    hInst, 0
        push    eax
        invoke  SetFocus, eax
        pop     eax
        invoke  SetWindowLong, eax, GWL_WNDPROC, addr SubClassNumbers
        mov     lpNumberProc, eax
        
        ;#####  Uppercase static
        invoke  CreateWindowEx, 
                    NULL, 
                    offset szWndClsStatic, 
                    offset szUppercase, 
                    WS_CHILD or WS_VISIBLE or SS_LEFT, 
                    5, 65, 
                    117, 17, 
                    hWin, 0, 
                    hInst, 0

        ;#####  Uppercase Edit
        invoke  CreateWindowEx, 
                    WS_EX_CLIENTEDGE, 
                    offset szWndClsEdit, 
                    NULL, 
                    WS_CHILD or WS_VISIBLE or WS_TABSTOP, 
                    5, 80, 
                    285, 20, 
                    hWin, 0, 
                    hInst, 0
        invoke  SetWindowLong, eax, GWL_WNDPROC, addr SubClassUpper
        mov     lpUpperProc, eax

        ;#####  Lowercase static
        invoke  CreateWindowEx, 
                    NULL, 
                    offset szWndClsStatic, 
                    offset szLowercase, 
                    WS_CHILD or WS_VISIBLE or SS_LEFT, 
                    5, 125, 
                    117, 17, 
                    hWin, 0, 
                    hInst, 0

        ;#####  Lowercase Edit
        invoke  CreateWindowEx, 
                    WS_EX_CLIENTEDGE, 
                    offset szWndClsEdit, 
                    NULL, 
                    WS_CHILD or WS_VISIBLE or WS_TABSTOP, 
                    5, 140, 
                    285, 20, 
                    hWin, 0, 
                    hInst, 0
        invoke  SetWindowLong, eax, GWL_WNDPROC, addr SubClassLower
        mov     lpLowerProc, eax
                
        ;#####  Hex static
        invoke  CreateWindowEx, 
                    NULL, 
                    offset szWndClsStatic, 
                    offset szHex, 
                    WS_CHILD or WS_VISIBLE or SS_LEFT, 
                    5, 185, 
                    117, 17, 
                    hWin, 0, 
                    hInst, 0

        ;#####  Hex Edit
        invoke  CreateWindowEx, 
                    WS_EX_CLIENTEDGE, 
                    offset szWndClsEdit, 
                    NULL, 
                    WS_CHILD or WS_VISIBLE or WS_TABSTOP, 
                    5, 200, 
                    285, 20, 
                    hWin, 0, 
                    hInst, 0
        invoke  SetWindowLong, eax, GWL_WNDPROC, addr SubClassHex
        mov     lpHexProc, eax        
        
        ;#####  Set all control fonts
        invoke  EnumChildWindows, hWin, addr SetControlFonts, NULL
        
    .elseif eax == WM_CLOSE
        invoke  DeleteObject, hFont
        invoke  DestroyWindow, hWin
        
    .elseif eax == WM_DESTROY
        invoke  PostQuitMessage, NULL
        
    .else    
        invoke  DefWindowProc, hWin, uMsg, wParam, lParam
        ret
    .endif
    xor     eax, eax
    ret
WndProcMain endp

SubClassNumbers proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax == WM_CHAR
	    mov     eax, wParam
	    .if (al >= 48 && al <= 57) || al == 8
	        ;#####  Only allow 0 - 9 and backspace keys
	        invoke 	CallWindowProc, lpUpperProc, hWin, uMsg, eax, lParam 
	        ret        
        .endif
	
	.else
	   invoke 	CallWindowProc, lpNumberProc, hWin, uMsg, wParam, lParam 
	    ret
	.endif

CharNotWanted:
    xor    eax, eax
	ret	

SubClassNumbers endp

SubClassUpper proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax == WM_CHAR
	    mov     eax, wParam
	    .if (al >= 65 && al <= 90) || (al >= 97 && al <= 122) || al == 8
	        ;#####  Only allow A - Z, a - z and backspace keys
	        ;#####  Make a - z uppercase
	        .if al >= 97 && al <= 122
	            sub     eax, 32
	        .endif
            invoke 	CallWindowProc, lpUpperProc, hWin, uMsg, eax, lParam 
	        ret
	    .endif
	            
	.else
	    invoke 	CallWindowProc, lpUpperProc, hWin, uMsg, wParam, lParam 
	    ret
	.endif
	
	xor    eax, eax
	ret

SubClassUpper endp

SubClassLower proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax == WM_CHAR
	    mov     eax, wParam
	    .if (al >= 65 && al <= 90) || (al >= 97 && al <= 122) || al == 8
	        ;#####  Only allow A - Z, a - z and backspace keys
	        ;#####  Make a - z lowercase
	        .if al >= 65 && al <= 90
	            add     eax, 32
	        .endif
            invoke 	CallWindowProc, lpLowerProc, hWin, uMsg, eax, lParam 
	        ret
	    .endif
	            
	.else
	    invoke 	CallWindowProc, lpLowerProc, hWin, uMsg, wParam, lParam 
	    ret
	.endif
	
	xor    eax, eax
	ret
	
SubClassLower endp

SubClassHex proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax == WM_CHAR
	    mov     eax, wParam
	    .if (al >= 48 && al <= 57) || (al >= 65 && al <= 70) || (al >= 97 && al <= 102) || al == 72 || al == 104 || al == 8
	        ;#####  Only allow 0 - 9, A - F, a - f, h, H and backspace keys
	        .if (al >= 97 && al <= 102) || al == 104
	            sub     eax, 32
	        .endif
	        invoke 	CallWindowProc, lpHexProc, hWin, uMsg, eax, lParam 
	        ret   

        .endif	

	.else
	    invoke 	CallWindowProc, lpHexProc, hWin, uMsg, wParam, lParam 
	    ret

	.endif
    xor    eax,eax
	ret	

SubClassHex endp

SetControlFonts proc hWin:DWORD, lParam:DWORD
    invoke  SendMessage, hWin, WM_SETFONT, hFont, FALSE 	
    mov     eax, TRUE
    ret
SetControlFonts endp

end start                                       